# coding: utf-8

"""
    Neops Workflow Engine

    Neops workflow engine API documentation

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class WorkflowExecutionParameters(BaseModel):
    """
    WorkflowExecutionParameters
    """ # noqa: E501
    device_query: StrictStr = Field(alias="deviceQuery")
    device_ids: List[StrictStr] = Field(description="Execution parameters", alias="deviceIds")
    interface_query: StrictStr = Field(description="Query to filter interfaces", alias="interfaceQuery")
    interface_ids: List[StrictStr] = Field(description="List of interfaces", alias="interfaceIds")
    group_query: StrictStr = Field(description="Query to filter groups", alias="groupQuery")
    group_ids: List[StrictStr] = Field(description="list of specific group IDs", alias="groupIds")
    client_query: StrictStr = Field(description="Query to filter Clients", alias="clientQuery")
    client_ids: List[StrictStr] = Field(description="List of specific client IDs", alias="clientIds")
    __properties: ClassVar[List[str]] = ["deviceQuery", "deviceIds", "interfaceQuery", "interfaceIds", "groupQuery", "groupIds", "clientQuery", "clientIds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of WorkflowExecutionParameters from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of WorkflowExecutionParameters from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "deviceQuery": obj.get("deviceQuery"),
            "deviceIds": obj.get("deviceIds"),
            "interfaceQuery": obj.get("interfaceQuery"),
            "interfaceIds": obj.get("interfaceIds"),
            "groupQuery": obj.get("groupQuery"),
            "groupIds": obj.get("groupIds"),
            "clientQuery": obj.get("clientQuery"),
            "clientIds": obj.get("clientIds")
        })
        return _obj


